// TsDescrambler.cpp: CTsDescrambler NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TsDescrambler.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// CTsDescrambler \z/
//////////////////////////////////////////////////////////////////////

CTsDescrambler::CTsDescrambler(IEventHandler *pEventHandler)
	: CMediaDecoder(pEventHandler, 1UL, 1UL)
	, m_dwInputPacketCount(0UL)
	, m_dwScramblePacketCount(0UL)
{
	// PATe[uPID}bvǉ
	m_PidMapManager.MapTarget(0x0000U, new CPatTable, OnPatUpdated, this);
}

CTsDescrambler::~CTsDescrambler()
{
	CloseBcasCard();
}

void CTsDescrambler::Reset(void)
{
	m_Queue.Clear();

	// Ԃ
	m_PidMapManager.UnmapAllTarget();

	// PATe[uPID}bvǉ
	m_PidMapManager.MapTarget(0x0000U, new CPatTable, OnPatUpdated, this);

	// vf[^
	m_dwInputPacketCount = 0UL;
	m_dwScramblePacketCount = 0UL;

	// fR[_
	CMediaDecoder::Reset();
}

const bool CTsDescrambler::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	if(dwInputIndex >= GetInputNum())return false;

	CTsPacket *pTsPacket = dynamic_cast<CTsPacket *>(pMediaData);

	// ̓fBAf[^͌݊Ȃ
	if(!pTsPacket)return false;

	// ̓pPbgJEg
	//if(m_dwInputPacketCount < 0xFFFFFFFFUL)m_dwInputPacketCount++;
	m_dwInputPacketCount++;

	if (!pTsPacket->IsScrambled() || IsTargetPID(pTsPacket->GetPID())) {
		// PID[eBO
		m_PidMapManager.StorePacket(pTsPacket);

		// pPbgo
		if (pTsPacket->IsScrambled()) {
			// RpPbgJEg
			//if(m_dwScramblePacketCount < 0xFFFFFFFFUL)m_dwScramblePacketCount++;
			m_dwScramblePacketCount++;
		}
	}

	// pPbgfR[_Ƀf[^n
	OutputMedia(pMediaData);

	return true;
}

const bool CTsDescrambler::OpenBcasCard(CCardReader::ReaderType ReaderType,DWORD *pErrorCode)
{
	CloseBcasCard();

	// J[h[_B-CASJ[hĊJ
	const bool bReturn = m_BcasCard.OpenCard(ReaderType);

	// G[R[hZbg
	if(pErrorCode)*pErrorCode = m_BcasCard.GetLastError();

	if (bReturn)
		m_Queue.BeginBcasThread();

	return bReturn;
}

void CTsDescrambler::CloseBcasCard(void)
{
	m_Queue.EndBcasThread();
	// B-CASJ[h
	m_BcasCard.CloseCard();
}

const bool CTsDescrambler::IsBcasCardOpen() const
{
	return m_BcasCard.IsCardOpen();
}

const bool CTsDescrambler::GetBcasCardID(BYTE *pCardID)
{
	// J[hID擾
	const BYTE *pBuff = m_BcasCard.GetBcasCardID();
	
	// obt@ɃRs[
	if(pCardID && pBuff)::CopyMemory(pCardID, pBuff, 6UL);
	
	return (pBuff)? true : false;
}

LPCTSTR CTsDescrambler::GetCardReaderName() const
{
	return m_BcasCard.GetCardReaderName();
}

const DWORD CTsDescrambler::GetInputPacketCount(void) const
{
	// ̓pPbgԂ
	return m_dwInputPacketCount;
}

const DWORD CTsDescrambler::GetScramblePacketCount(void) const
{
	// RpPbgԂ
	return m_dwScramblePacketCount;
}

bool CTsDescrambler::SetTargetPID(const WORD *pPIDList,int NumPIDs)
{
	CBlockLock Lock(&m_DescrambleListLock);

	TRACE(TEXT("CTsDescrambler::SetTargetPID()\n"));
	m_DescramblePIDList.clear();
	if (pPIDList!=NULL) {
		for (int i=0;i<NumPIDs;i++) {
			TRACE(TEXT("Descramble target PID %d = %04x\n"),i,pPIDList[i]);
			m_DescramblePIDList.push_back(pPIDList[i]);
		}
	}
	return true;
}

bool CTsDescrambler::IsTargetPID(WORD PID)
{
	CBlockLock Lock(&m_DescrambleListLock);

	if (m_DescramblePIDList.size()==0)
		return true;
	for (size_t i=0;i<m_DescramblePIDList.size();i++) {
		if (m_DescramblePIDList[i]==PID)
			return true;
	}
	return false;
}

void CALLBACK CTsDescrambler::OnPatUpdated(const WORD wPID, CTsPidMapTarget *pMapTarget, CTsPidMapManager *pMapManager, const PVOID pParam)
{
	// PATXVꂽ
	CTsDescrambler *pThis = static_cast<CTsDescrambler *>(pParam);
	CPatTable *pPatTable = dynamic_cast<CPatTable *>(pMapTarget);

#ifdef _DEBUG
	if(!pPatTable)::DebugBreak();
#endif

	// PMTe[uPID}bvǉ
	for(WORD wIndex = 0U ; wIndex < pPatTable->GetProgramNum() ; wIndex++){
		pMapManager->MapTarget(pPatTable->GetPmtPID(wIndex), new CPmtTable, OnPmtUpdated, pParam);
	}
}

void CALLBACK CTsDescrambler::OnPmtUpdated(const WORD wPID, CTsPidMapTarget *pMapTarget, CTsPidMapManager *pMapManager, const PVOID pParam)
{
	// PMTXVꂽ
	CTsDescrambler *pThis = static_cast<CTsDescrambler *>(pParam);
	CPmtTable *pPmtTable = dynamic_cast<CPmtTable *>(pMapTarget);

#ifdef _DEBUG
	if(!pPmtTable)::DebugBreak();
#endif

	// ECMPID}bvǉ
	const WORD wEcmPID = pPmtTable->GetEcmPID();
	if(wEcmPID >= 0x1FFFU)return;

	// ECM^[QbgmF
	CEcmProcessor *pEcmProcessor = dynamic_cast<CEcmProcessor *>(pMapManager->GetMapTarget(wEcmPID));

	if (!pEcmProcessor) {
		// ECMNXVK}bv
		pEcmProcessor = new CEcmProcessor(pThis, &pThis->m_BcasCard, &pThis->m_Queue);
		pMapManager->MapTarget(wEcmPID, pEcmProcessor);
	}

	// ESPID}bvǉ
	for (WORD wIndex = 0U ; wIndex < pPmtTable->GetEsInfoNum() ; wIndex++) {
		pEcmProcessor->AddEsPID(pPmtTable->GetEsPID(wIndex));
		pMapManager->MapTarget(pPmtTable->GetEsPID(wIndex), new CEsProcessor(pEcmProcessor), NULL, pParam);
	}
}


//////////////////////////////////////////////////////////////////////
// CEcmProcessor \z/
//////////////////////////////////////////////////////////////////////

CEcmProcessor::CEcmProcessor(CTsDescrambler *pDescrambler, CBcasCard *pBcasCard, CBcasAccessQueue *pQueue)
	: CDynamicReferenceable()
	, CPsiSingleTable(true)
	, m_pDescrambler(pDescrambler)
	, m_pBcasCard(pBcasCard)
	, m_pQueue(pQueue)
	, m_bInQueue(false)
	, m_bSetScrambleKey(false)
	, m_bLastEcmSucceed(true)
{
	// MULTI2fR[_ɃVXeL[ƏCBCZbg
	m_Multi2Decoder.Initialize(m_pBcasCard->GetSystemKey(), m_pBcasCard->GetInitialCbc());
}

void CEcmProcessor::OnPidMapped(const WORD wPID, const PVOID pParam)
{
	// QƃJEgǉ
	AddRef();
}

void CEcmProcessor::OnPidUnmapped(const WORD wPID)
{
	// QƃJEgJ
	ReleaseRef();
}

const bool CEcmProcessor::DescramblePacket(CTsPacket *pTsPacket)
{
	if (!m_bInQueue)	// ܂ECMĂȂ
		return false;
	for (int i=0;!m_bSetScrambleKey;i++) {
		if (i==500)	// fbhbN
			return false;
		Sleep(1);
	}
	// XNu
	m_Multi2Lock.Lock();
	bool bOK=m_Multi2Decoder.Decode(pTsPacket->GetPayloadData(),
									(DWORD)pTsPacket->GetPayloadSize(),
									pTsPacket->m_Header.byTransportScramblingCtrl);
	m_Multi2Lock.Unlock();
	if (bOK) {
		// gX|[gXNuĐݒ
		pTsPacket->SetAt(3UL, pTsPacket->GetAt(3UL) & 0x3FU);
		pTsPacket->m_Header.byTransportScramblingCtrl = 0U;
	}
	return bOK;
}

const bool CEcmProcessor::OnTableUpdate(const CPsiSection *pCurSection, const CPsiSection *pOldSection)
{
#if 0
	return SetScrambleKey(pCurSection->GetPayloadData(), pCurSection->GetPayloadSize());
#else
	// B-CASANZXL[ɒǉ
	if (m_pQueue->Enqueue(this, pCurSection->GetPayloadData(), pCurSection->GetPayloadSize()))
		m_bInQueue=true;
#endif
	return true;
}

const bool CEcmProcessor::SetScrambleKey(const BYTE *pEcmData, DWORD EcmSize)
{
	bool bHasTargetPID=false;
	for (size_t i=0;i<m_EsPIDList.size();i++) {
		if (m_pDescrambler->IsTargetPID(m_EsPIDList[i])) {
			bHasTargetPID=true;
			break;
		}
	}
	if (!bHasTargetPID)
		return false;

	// ECMB-CASJ[hɓnăL[擾
	const BYTE *pKsData = m_pBcasCard->GetKsFromEcm(pEcmData, EcmSize);

	// ECMs͈xB-CASJ[hď
	if (!pKsData && m_bLastEcmSucceed && (m_pBcasCard->GetLastError() != BCEC_ECMREFUSED)){
		if (m_pBcasCard->ReOpenCard()) {
			TRACE(TEXT("CTsDescrambler::CEcmProcessor::SetScrambleKey() Re open card.\n"));
			pKsData = m_pBcasCard->GetKsFromEcm(pEcmData, EcmSize);
		}
	}

	// XNuL[XV
	m_Multi2Lock.Lock();
	m_Multi2Decoder.SetScrambleKey(pKsData);
	m_Multi2Lock.Unlock();

	// ECMԍXV
	m_bLastEcmSucceed = pKsData!=NULL;

	m_bSetScrambleKey=true;

	return true;
}

const bool CEcmProcessor::AddEsPID(WORD PID)
{
	m_EsPIDList.push_back(PID);
	return true;
}


//////////////////////////////////////////////////////////////////////
// CTsDescrambler::CEsProcessor \z/
//////////////////////////////////////////////////////////////////////

CTsDescrambler::CEsProcessor::CEsProcessor(CEcmProcessor *pEcmProcessor)
	: CTsPidMapTarget()
	, m_pEcmProcessor(pEcmProcessor)
{
	// QƃJEgǉ
	m_pEcmProcessor->AddRef();
}

CTsDescrambler::CEsProcessor::~CEsProcessor()
{
	// QƃJEg폜
	m_pEcmProcessor->ReleaseRef();
}

const bool CTsDescrambler::CEsProcessor::StorePacket(const CTsPacket *pPacket)
{
	// XNu
	m_pEcmProcessor->DescramblePacket(const_cast<CTsPacket *>(pPacket));

	return false;
}

void CTsDescrambler::CEsProcessor::OnPidUnmapped(const WORD wPID)
{
	// CX^XJ
	delete this;
}




CBcasAccess::CBcasAccess(CEcmProcessor *pEcmProcessor, const BYTE *pData, DWORD Size)
{
	m_pEcmProcessor = pEcmProcessor;
	m_pEcmProcessor->AddRef();
	::CopyMemory(m_EcmData, pData, Size);
	m_EcmSize = Size;
}


CBcasAccess::CBcasAccess(const CBcasAccess &BcasAccess)
{
	m_pEcmProcessor = BcasAccess.m_pEcmProcessor;
	m_pEcmProcessor->AddRef();
	::CopyMemory(m_EcmData, BcasAccess.m_EcmData, BcasAccess.m_EcmSize);
	m_EcmSize = BcasAccess.m_EcmSize;
}


CBcasAccess::~CBcasAccess()
{
	m_pEcmProcessor->ReleaseRef();
}


CBcasAccess &CBcasAccess::operator=(const CBcasAccess &BcasAccess)
{
	m_pEcmProcessor->ReleaseRef();
	m_pEcmProcessor = BcasAccess.m_pEcmProcessor;
	m_pEcmProcessor->AddRef();
	::CopyMemory(m_EcmData, BcasAccess.m_EcmData, BcasAccess.m_EcmSize);
	m_EcmSize = BcasAccess.m_EcmSize;
	return *this;
}


bool CBcasAccess::SetScrambleKey()
{
	return m_pEcmProcessor->SetScrambleKey(m_EcmData, m_EcmSize);
}




CBcasAccessQueue::CBcasAccessQueue()
	: m_hThread(NULL)
	, m_hEvent(NULL)
	, m_bKillEvent(false)
{
}


CBcasAccessQueue::~CBcasAccessQueue()
{
	EndBcasThread();
	//Clear();
}


void CBcasAccessQueue::Clear()
{
	CBlockLock Lock(&m_Lock);

	m_Queue.clear();
}


bool CBcasAccessQueue::Enqueue(CEcmProcessor *pEcmProcessor, const BYTE *pData, DWORD Size)
{
	if (!m_hThread || Size>256)
		return false;

	CBlockLock Lock(&m_Lock);

	CBcasAccess BcasAccess(pEcmProcessor, pData, Size);
	m_Queue.push_back(BcasAccess);
	::SetEvent(m_hEvent);
	return true;
}


bool CBcasAccessQueue::BeginBcasThread()
{
	if (m_hThread)
		return false;
	DWORD ThreadID;
	m_hEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL);
	m_bKillEvent = false;
	m_hThread = ::CreateThread(NULL, 0, BcasAccessThread, this, 0, &ThreadID);
	if (m_hThread == NULL) {
		::CloseHandle(m_hEvent);
		m_hEvent = NULL;
		return false;
	}
	return true;
}


bool CBcasAccessQueue::EndBcasThread()
{
	if (m_hThread) {
		m_bKillEvent = true;
		::SetEvent(m_hEvent);
		if (::WaitForSingleObject(m_hThread, 1000) == WAIT_TIMEOUT) {
			::TerminateThread(m_hThread, 1);
		}
		::CloseHandle(m_hThread);
		m_hThread = NULL;
		::CloseHandle(m_hEvent);
		m_hEvent = NULL;
	}
	return true;
}


DWORD CALLBACK CBcasAccessQueue::BcasAccessThread(LPVOID lpParameter)
{
	CBcasAccessQueue *pThis=static_cast<CBcasAccessQueue*>(lpParameter);

	while (true) {
		::WaitForSingleObject(pThis->m_hEvent, INFINITE);
		if (pThis->m_bKillEvent)
			break;
		while (true) {
			pThis->m_Lock.Lock();
			if (pThis->m_Queue.empty()) {
				pThis->m_Lock.Unlock();
				break;
			}
			CBcasAccess BcasAccess = pThis->m_Queue.front();
			pThis->m_Queue.pop_front();
			pThis->m_Lock.Unlock();
			BcasAccess.SetScrambleKey();
		}
	}
	return 0;
}
